/*
 * Copyright 2010, Red Hat, Inc., and individual contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.cdi.tck.tests.context.application.ejb;

import jakarta.ejb.Stateless;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.enterprise.context.ContextNotActiveException;
import jakarta.enterprise.context.spi.Context;
import jakarta.enterprise.inject.spi.BeanManager;
import jakarta.inject.Inject;

@Stateless
public class FooBean implements FooRemote {

    @Inject
    private BeanManager beanManager;

    @Inject
    SimpleApplicationBean simpleApplicationBean;

    @Override
    public Double ping() {

        Context applicationContext = null;

        try {
            applicationContext = beanManager.getContext(ApplicationScoped.class);
        } catch (ContextNotActiveException e) {
            // No-op
        }

        if (applicationContext == null || !applicationContext.isActive() || simpleApplicationBean == null) {
            return null;
        }
        return simpleApplicationBean.getId();
    }

}
